clear all
close all

l1 = 2;
l2 = 2;
l3 = 2;

%Jacobian based inverse kinematics with redundancy, the current joint angles,theta1,theta2,theta3 need to be
%known

theta1 = 0.5;
theta2 = 0.7;
theta3 = 0.4;
    
px0 = l1*cos(theta1)+l2*cos(theta2+theta1)+l3*cos(theta3+theta2+theta1);
py0 = l1*sin(theta1)+l2*sin(theta2+theta1)+l3*sin(theta3+theta2+theta1);

previous_e=0;

%the stiffness of the environment 
K=[2,0;0,2]

%desired force vector applied on the fingertip
fd=[2,2]';

%object indicated as a circle
cen_ox = 1.2; % centre of the circle obstacle x position
cen_oy = 4.0; % centre of the circle obstacle y position

ox = cen_ox;
oy = cen_oy;
  
% Points values surround the circle obstacle to draw circle..
ang=0:0.01:2*pi; 

oxp=cos(ang)+cen_ox;
oyp=sin(ang)+cen_oy;

%initial force is zero
fe=0;

%set the time interval is 1
dt=1;

%KP proportional gain, KD derivative gain
KP=0.3;


figure(1)

for i=1:100

%%P controller implementation     
e = ;

%store the error into an array for display
error(:,i)=e;

%%

    
[theta1,theta2,theta3]=IK_redundant_control(dx,theta1,theta2,theta3,l1,l2,l3);
       

pxk = l1*cos(theta1)+l2*cos(theta2+theta1)+l3*cos(theta3+theta2+theta1);
pyk = l1*sin(theta1)+l2*sin(theta2+theta1)+l3*sin(theta3+theta2+theta1);

pxr(i)=pxk;
pyr(i)=pyk;

%%simulate the force generated by the displacement
dpx=pxk-px0;
dpy=pyk-py0;
fe=-K*[dpx,dpy]';

%%
l1x(i) =   l1*cos(theta1);
l1y(i) =   l1*sin(theta1);

l2x(i) =   l1*cos(theta1)+l2*cos(theta2+theta1);
l2y(i) =   l1*sin(theta1)+l2*sin(theta2+theta1);

l3x(i) =  l1*cos(theta1)+l2*cos(theta2+theta1)+l3*cos(theta3+theta2+theta1);   
l3y(i) =  l1*sin(theta1)+l2*sin(theta2+theta1)+l3*sin(theta3+theta2+theta1);

plot(pxr,pyr,'k*')
line([0 l1x(i)],[0 l1y(i)],'LineWidth',4,'Color',[1 0 0])
line([l1x(i); l2x(i)],[l1y(i); l2y(i)],'LineWidth',4,'Color',[0 1 0])
line([l2x(i); l3x(i)],[l2y(i); l3y(i)],'LineWidth',4,'Color',[0 0 1])
drawnow;
pause(0.01);

end



%error for Jacobian based PD force control
errorfx=error(1,:);
errorfy=error(2,:);


figure(2)
plot(errorfx,'b-')
hold on
plot(errorfy,'r-')
title('force control error','FontSize',14)


